%
%   hit_the_target.m
%
% Gioco del cannone.
% 

clear all;
close all;
clc;

pos_cannone = [0 0];

noise_ang = 1; % l'angolo dichiarato sara' disturbato da una distr
               % uniforme [-noise_ang +noise_ang] 
noise_pos = 5; % la posizione dichiarata sara' disturbata da una distr
               % uniforme [-noise_pos +noise_pos]

dim_bersaglio = 5;

campo = [-10 510 -10 310]; % limiti del campo di gioco
                          % [min_X max_X min_Y max_Y]

dt = .1; 
g = 9.81;

circle_x = cos(0:.1:2*pi);
circle_y = sin(0:.1:2*pi);
circle_x = circle_x([1:end 1]);
circle_y = circle_y([1:end 1]);

HIT = 0;

DATA_OK = 0;

if verLessThan('matlab', '8.5'),
    round((cputime-floor(cputime))*1000);
else
    rng('shuffle');
end;

while (DATA_OK == 0),
    % angolo di inclinazione del cannone
    ang_cannone = rand(1)*(80-10)+10;
    ang_cannone_dich = ang_cannone+rand(1)*2*noise_ang-noise_ang;
    
    vel_true = rand(1)*100+10;
    x_b = rand(1)*(campo(2)-10)+10;
    a = deg2rad(ang_cannone);
    y_b = x_b*tan(a)-g*x_b^2/(2*vel_true^2*cos(a)^2);
    pos_bersaglio = [x_b y_b];
    pos_bersaglio_dich = pos_bersaglio+rand(1,2)*noise_pos-noise_pos*[1 1];
    
    if (all(pos_bersaglio_dich > 10) && all(pos_bersaglio_dich < campo([2 4]))),
        DATA_OK = 1;
    end;
end;
hf = figure;
set(hf, 'WindowStyle', 'docked');
hold on;
plot(pos_bersaglio(1), pos_bersaglio(2), 'x', 'MarkerSize', 10);
plot(pos_bersaglio(1)+circle_x*dim_bersaglio, pos_bersaglio(2)+circle_y*dim_bersaglio, '-', 'LineWidth', 2);
plot([-20*cos(deg2rad(ang_cannone_dich)) 0],...
     [-20*sin(deg2rad(ang_cannone_dich)) 0], 'LineWidth', 5);
axis(campo);
%axis equal;
%axis off;

prompt_str = sprintf('angolo: %.2f  pos: (%.2f, %.2f)  velocita'': ',...
                     ang_cannone_dich, pos_bersaglio_dich);

%fprintf('%.2f %.2f %.2f\n', ang_cannone_dich, pos_bersaglio_dich);

while (HIT==0),

    %x = pos_bersaglio(1);
    %y = pos_bersaglio(2);
    %a = deg2rad(ang_cannone);
    % vel_cannone = sqrt(g*x^2/(2*cos(a)^2*(x*tan(a)-y))),

    % legge vel_cannone
    
    vel_cannone = input(prompt_str);
    
    vel_x = vel_cannone*cos(deg2rad(ang_cannone));
    vel_y = vel_cannone*sin(deg2rad(ang_cannone));
    max_t = (campo(2)-pos_cannone(1))/vel_x;

    t = 0:dt:max_t;
    lt = length(t);
    pos_x = pos_cannone(1) + t*vel_x; 
    pos_y = pos_cannone(2) + t*vel_y - 1/2*9.81*t.^2; 
    
    dist = sqrt((pos_x-pos_bersaglio(1)).^2+(pos_y-pos_bersaglio(2)).^2);
    ind = find(dist<dim_bersaglio);
    if (~isempty(ind)),
        pos_x = pos_x(1:ind(1));
        pos_y = pos_y(1:ind(1));
        HIT = 1;
    end;
    
    figure(hf);
    set(hf, 'WindowStyle', 'docked');
    clf;
    hold on;
    plot(pos_x, pos_y, 'o');
    plot([-20*cos(deg2rad(ang_cannone_dich)) 0],...
         [-20*sin(deg2rad(ang_cannone_dich)) 0], 'LineWidth', 5);
    plot(pos_bersaglio(1), pos_bersaglio(2), 'x', 'MarkerSize', 10);
    plot(pos_bersaglio(1)+circle_x*dim_bersaglio, pos_bersaglio(2)+circle_y*dim_bersaglio, '-', 'LineWidth', 2);
    axis(campo);
    %    axis equal;
    if (HIT == 1),
        h = plot(pos_bersaglio(1), pos_bersaglio(2), 'pr', 'MarkerSize', 5);
        axis(campo);
        %axis equal;
        drawnow;
        for i = 1:7,
            set(h, 'MarkerSize', 5*1.3^(i));
            pause(.1);
            axis(campo);
            %axis equal;
            drawnow;
        end;
        for i = 7:-1:3,
            set(h, 'MarkerSize', 5*1.3^(i));
            pause(.1);
            axis(campo);
            %axis equal;
            drawnow;
        end;
    end;
        
    %axis off
end;

fprintf('%.2f %.2f %.2f %.2f\n', ang_cannone_dich, pos_bersaglio_dich, vel_cannone);

URL = ['https://homes.di.unimi.it/ferrari/RetiNeurali_2016/raccolta_hit_the_target.php?'...
       'ang=' num2str(ang_cannone_dich)...
       '&posX=' num2str(pos_bersaglio_dich(1))...
       '&posY=' num2str(pos_bersaglio_dich(2))...
       '&vel=' num2str(vel_cannone)];

[str status] = urlread(URL);
